.\" $FreeBSD: src/share/man/man4/ch.4,v 1.5.2.5 1999/09/05 11:26:56 peter Exp $
.\" Copyright (c) 1996
.\"	Julian Elischer <julian@freebsd.org>.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\"
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.Dd August 27, 1993
.Dt CH 4
.Os FreeBSD
.Sh NAME
.Nm ch
.Nd scsi media-changer (juke box) driver
.Sh SYNOPSIS
.Cd device ch
.Cd device ch1 target 4 lun 0
.Sh DESCRIPTION
The
.Xr ch
driver provides support for a 
.Em scsi
juke box. It allows many slots of media to be multiplexed between a number
of drives.
.Pp
A scsi adapter must also be separately configured into the system
before a scsi changer can be configured.
.Pp
As the scsi adapter is probed during boot, the 
.Em SCSI
bus is scanned for devices. Any devices found which answer as 'Changer'
type devices will be 'attached' to the 
.Nm
driver.
In FreeBSD releases prior to 2.1, the first found will be attached as
.Em ch0
and the next, 
.Em ch1
etc.
Beginning in 2.1 it is possible to specify what ch unit a device should
come on line as; refer to
.Xr scsi 4
for details on kernel configuration.
.Pp

.Sh KERNEL CONFIGURATION
In configuring, if an optional
.Ar count
is given in the specification, that number of scsi media changers
are configured; Most storage for them is allocated only when found
so a large number of configured devices is cheap. (once the first
has included the driver).

.Pp
.Sh IOCTLS
The following 
.Xr ioctl 2
call applies to the changer. It is defined in
in the header file
.Em sys/chio.h.

.Bl -tag -width DIOCSDINFO
CHIOOP	
This appears to be a 'do-everything' call.
.El
.Sh NOTES
The 
.Nm
driver was added to the system by
   Stefan Grefen (grefen@goofy.zdv.uni-mainz.de)
who apparently had such a device
however It appears as though no-one I have heard of has ever used this
driver. If you use it please let me know so I can test changes.
Stefan appears to have suffered net.death (or at least net.disconnection).
I (julian) have never used this device. If you do please re-write this
man page and send it to me..

.Sh FILES
.Bl -tag -width /dev/ch[0-9] -compact
.It Pa /dev/ch[0-9]
device entries
.El
.Sh DIAGNOSTICS
None.
.Sh SEE ALSO
.Xr chio 1 ,
.Xr cd 4 ,
.Xr sd 4 ,
.Xr st 4
.Sh HISTORY
The
.Nm
driver appeared in 386BSD 0.1.
